<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.5"/>
<title>Advanced Cuts for Cooperative OPF: decoop::PlantbusSubproblemL1 Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">Advanced Cuts for Cooperative OPF
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.5 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Friends</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedecoop.html">decoop</a></li><li class="navelem"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html">PlantbusSubproblemL1</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdecoop_1_1_plantbus_subproblem_l1-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">decoop::PlantbusSubproblemL1 Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Provides an interface for solving L1 subproblems and adding cuts from such problems.  
 <a href="classdecoop_1_1_plantbus_subproblem_l1.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="coop_benders_subproblem_l1_8hpp_source.html">coopBendersSubproblemL1.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a5f8dfc0bca82b1f5aae9b854f2608578"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a5f8dfc0bca82b1f5aae9b854f2608578">PlantbusSubproblemL1</a> (const GRBEnv &amp;env, const std::string &amp;option_path, const double plant_load, const unsigned num_timesteps)</td></tr>
<tr class="memdesc:a5f8dfc0bca82b1f5aae9b854f2608578"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#a5f8dfc0bca82b1f5aae9b854f2608578">More...</a><br/></td></tr>
<tr class="separator:a5f8dfc0bca82b1f5aae9b854f2608578"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6de9f886669346f05746dd6b22e768f1"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a6de9f886669346f05746dd6b22e768f1"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a6de9f886669346f05746dd6b22e768f1">Solve</a> ()</td></tr>
<tr class="memdesc:a6de9f886669346f05746dd6b22e768f1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Solves the subproblem with the currently held power profile suggestion. <br/></td></tr>
<tr class="separator:a6de9f886669346f05746dd6b22e768f1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac4b94c28d900106779deb55571355bcc"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ac4b94c28d900106779deb55571355bcc">GetModelStatus</a> () const </td></tr>
<tr class="memdesc:ac4b94c28d900106779deb55571355bcc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns status code of the <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab46930555472c4d857991655324ccb65" title="L1 subproblem model. ">model_</a>. See Gurobi reference manual for meaning of codes.  <a href="#ac4b94c28d900106779deb55571355bcc">More...</a><br/></td></tr>
<tr class="separator:ac4b94c28d900106779deb55571355bcc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a91ffead887f3d8961ca6d787b93168d9"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a91ffead887f3d8961ca6d787b93168d9">GetNewRhs</a> () const </td></tr>
<tr class="memdesc:a91ffead887f3d8961ca6d787b93168d9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes right hand side of the cut generated from current power profile suggestion.  <a href="#a91ffead887f3d8961ca6d787b93168d9">More...</a><br/></td></tr>
<tr class="separator:a91ffead887f3d8961ca6d787b93168d9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a463a29b7d2cf7b121cb9b5c69992cb98"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a463a29b7d2cf7b121cb9b5c69992cb98">GetCurrLhs</a> () const </td></tr>
<tr class="memdesc:a463a29b7d2cf7b121cb9b5c69992cb98"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes value of the left hand side of the generated cut when current power profile suggestion is inserted.  <a href="#a463a29b7d2cf7b121cb9b5c69992cb98">More...</a><br/></td></tr>
<tr class="separator:a463a29b7d2cf7b121cb9b5c69992cb98"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6e9aa900dfe5f0882030abd72a7a7f7a"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a6e9aa900dfe5f0882030abd72a7a7f7a">GetNewCoeff</a> (const unsigned key) const </td></tr>
<tr class="memdesc:a6e9aa900dfe5f0882030abd72a7a7f7a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes coefficient of the left hand side of the cut for a given timestep.  <a href="#a6e9aa900dfe5f0882030abd72a7a7f7a">More...</a><br/></td></tr>
<tr class="separator:a6e9aa900dfe5f0882030abd72a7a7f7a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a86935d2f7bdf0caf1f0d1b9ee6ccb7df"><td class="memItemLeft" align="right" valign="top">std::vector&lt; double &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a86935d2f7bdf0caf1f0d1b9ee6ccb7df">GetNewCoeffs</a> () const </td></tr>
<tr class="memdesc:a86935d2f7bdf0caf1f0d1b9ee6ccb7df"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes all coefficients of the left hand side of the cut.  <a href="#a86935d2f7bdf0caf1f0d1b9ee6ccb7df">More...</a><br/></td></tr>
<tr class="separator:a86935d2f7bdf0caf1f0d1b9ee6ccb7df"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a148da0d8b1e81458343ad5e95b38ecec"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a148da0d8b1e81458343ad5e95b38ecec">GetSubproblemObjective</a> () const </td></tr>
<tr class="memdesc:a148da0d8b1e81458343ad5e95b38ecec"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns objective value of the <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab46930555472c4d857991655324ccb65" title="L1 subproblem model. ">model_</a>.  <a href="#a148da0d8b1e81458343ad5e95b38ecec">More...</a><br/></td></tr>
<tr class="separator:a148da0d8b1e81458343ad5e95b38ecec"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2573240404d563487c1f25829b3b4eb9"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a2573240404d563487c1f25829b3b4eb9">GenerateAndVerifyCut</a> () const </td></tr>
<tr class="memdesc:a2573240404d563487c1f25829b3b4eb9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes right hand side of the cut, verifies its correctness and ensures that current power profile suggestion is cut off.  <a href="#a2573240404d563487c1f25829b3b4eb9">More...</a><br/></td></tr>
<tr class="separator:a2573240404d563487c1f25829b3b4eb9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2d937ee5b1256ebfff0f5a79f792d98c"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a2d937ee5b1256ebfff0f5a79f792d98c">get_plant_load</a> () const </td></tr>
<tr class="memdesc:a2d937ee5b1256ebfff0f5a79f792d98c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns flexible load of this subproblem in MW.  <a href="#a2d937ee5b1256ebfff0f5a79f792d98c">More...</a><br/></td></tr>
<tr class="separator:a2d937ee5b1256ebfff0f5a79f792d98c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae4531793f2eec41039c4be4905eec28e"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ae4531793f2eec41039c4be4905eec28e">ComputeFeasDistance</a> () const </td></tr>
<tr class="memdesc:ae4531793f2eec41039c4be4905eec28e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes distance between suggested power profile and the feasible profile found by the subproblem. Unit is MW.  <a href="#ae4531793f2eec41039c4be4905eec28e">More...</a><br/></td></tr>
<tr class="separator:ae4531793f2eec41039c4be4905eec28e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a590527bb3ccf8a97aeb320c1d54b5dd5"><td class="memItemLeft" align="right" valign="top">std::vector&lt; double &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a590527bb3ccf8a97aeb320c1d54b5dd5">ComputeFeasSol</a> () const </td></tr>
<tr class="memdesc:a590527bb3ccf8a97aeb320c1d54b5dd5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes the feasible power profile found by the subproblem. Unit is MW.  <a href="#a590527bb3ccf8a97aeb320c1d54b5dd5">More...</a><br/></td></tr>
<tr class="separator:a590527bb3ccf8a97aeb320c1d54b5dd5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab15d67a0a1a85ef286644e6a29d0b1cf"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab15d67a0a1a85ef286644e6a29d0b1cf">ComputeFeasSol</a> (const unsigned key) const </td></tr>
<tr class="memdesc:ab15d67a0a1a85ef286644e6a29d0b1cf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes entry of the feasible power profile at given timestep found by the subproblem. Unit is MW.  <a href="#ab15d67a0a1a85ef286644e6a29d0b1cf">More...</a><br/></td></tr>
<tr class="separator:ab15d67a0a1a85ef286644e6a29d0b1cf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a338929b552e8af9a7612f3bb4ae12a32"><td class="memItemLeft" align="right" valign="top">std::vector&lt; double &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a338929b552e8af9a7612f3bb4ae12a32">GetNSlackValues</a> () const </td></tr>
<tr class="memdesc:a338929b552e8af9a7612f3bb4ae12a32"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns values of negative slack variables.  <a href="#a338929b552e8af9a7612f3bb4ae12a32">More...</a><br/></td></tr>
<tr class="separator:a338929b552e8af9a7612f3bb4ae12a32"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab8a27c2b34a6bef9695e76b42c6a62f3"><td class="memItemLeft" align="right" valign="top">std::vector&lt; double &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab8a27c2b34a6bef9695e76b42c6a62f3">GetPSlackValues</a> () const </td></tr>
<tr class="memdesc:ab8a27c2b34a6bef9695e76b42c6a62f3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns values of positive slack variables.  <a href="#ab8a27c2b34a6bef9695e76b42c6a62f3">More...</a><br/></td></tr>
<tr class="separator:ab8a27c2b34a6bef9695e76b42c6a62f3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a973d94c4cd81963a10dd736488044d16"><td class="memItemLeft" align="right" valign="top">std::vector&lt; double &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a973d94c4cd81963a10dd736488044d16">get_pow_sugg</a> () const </td></tr>
<tr class="memdesc:a973d94c4cd81963a10dd736488044d16"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns power profile suggestion. Unit is multiples of flexible load.  <a href="#a973d94c4cd81963a10dd736488044d16">More...</a><br/></td></tr>
<tr class="separator:a973d94c4cd81963a10dd736488044d16"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5cb28e40dc33f9a1e84c4ef4def157b3"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a5cb28e40dc33f9a1e84c4ef4def157b3">get_pow_sugg</a> (const unsigned i) const </td></tr>
<tr class="memdesc:a5cb28e40dc33f9a1e84c4ef4def157b3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns entry of the power profile suggestion at a given timestep. Unit is multiples of flexible load.  <a href="#a5cb28e40dc33f9a1e84c4ef4def157b3">More...</a><br/></td></tr>
<tr class="separator:a5cb28e40dc33f9a1e84c4ef4def157b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aad54229e7d85a7a6cb8cf2eeb56a169a"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#aad54229e7d85a7a6cb8cf2eeb56a169a">set_pow_sugg</a> (const std::vector&lt; double &gt; &amp;in)</td></tr>
<tr class="memdesc:aad54229e7d85a7a6cb8cf2eeb56a169a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets power profile suggestion.  <a href="#aad54229e7d85a7a6cb8cf2eeb56a169a">More...</a><br/></td></tr>
<tr class="separator:aad54229e7d85a7a6cb8cf2eeb56a169a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4c1012cde8398a015a1527af62a8c6b6"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a4c1012cde8398a015a1527af62a8c6b6">set_pow_sugg</a> (const unsigned key, const double val)</td></tr>
<tr class="memdesc:a4c1012cde8398a015a1527af62a8c6b6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets power suggestion at single timestep.  <a href="#a4c1012cde8398a015a1527af62a8c6b6">More...</a><br/></td></tr>
<tr class="separator:a4c1012cde8398a015a1527af62a8c6b6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac4ddb1eaeeb0a48bcd5a06c36586efe5"><td class="memItemLeft" align="right" valign="top">GRBModel &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ac4ddb1eaeeb0a48bcd5a06c36586efe5">GetModel</a> ()</td></tr>
<tr class="memdesc:ac4ddb1eaeeb0a48bcd5a06c36586efe5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns reference to <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab46930555472c4d857991655324ccb65" title="L1 subproblem model. ">model_</a> object.  <a href="#ac4ddb1eaeeb0a48bcd5a06c36586efe5">More...</a><br/></td></tr>
<tr class="separator:ac4ddb1eaeeb0a48bcd5a06c36586efe5"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:ab119d790de2b3b817927acfa1d2e314e"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab119d790de2b3b817927acfa1d2e314e">InitObject</a> ()</td></tr>
<tr class="memdesc:ab119d790de2b3b817927acfa1d2e314e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Fills <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab21709857572f155cb0a25abbbaa354e" title="Indices of the equations in equations_ that represent the coupling equation (1 entry per timestep)...">coupling_equation_</a>, <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#abc8fb896970fdcf7b656bbb29dcff49e" title="Indices of all entries in equations_ that are not a coupling equation. ">constraints_</a>, <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a2bc98f8ace120aa946f6fde01ca31a03" title="Indices of all entries in variables_ that are part of the plant model. ">model_vars_</a>, <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ae2ec2c96547283c1752defa3e52633bd" title="Indices of all entries in variables_ that are negative slack variables. ">n_slack_</a> and <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a6e9d84692dcec80f37e39dc5ca5fcb5b" title="Indices of all entries in variables_ that are positive slack variables. ">p_slack_</a>.  <a href="#ab119d790de2b3b817927acfa1d2e314e">More...</a><br/></td></tr>
<tr class="separator:ab119d790de2b3b817927acfa1d2e314e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:af6cd150f833e021a84629a8e076abc85"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af6cd150f833e021a84629a8e076abc85"></a>
const <a class="el" href="structdecoop_1_1_subproblem_options.html">SubproblemOptions</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#af6cd150f833e021a84629a8e076abc85">options_</a></td></tr>
<tr class="memdesc:af6cd150f833e021a84629a8e076abc85"><td class="mdescLeft">&#160;</td><td class="mdescRight">Holds options specified by user in option file. <br/></td></tr>
<tr class="separator:af6cd150f833e021a84629a8e076abc85"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab46930555472c4d857991655324ccb65"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab46930555472c4d857991655324ccb65"></a>
GRBModel&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab46930555472c4d857991655324ccb65">model_</a></td></tr>
<tr class="memdesc:ab46930555472c4d857991655324ccb65"><td class="mdescLeft">&#160;</td><td class="mdescRight">L1 subproblem model. <br/></td></tr>
<tr class="separator:ab46930555472c4d857991655324ccb65"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a98c6106ebbbb2c77cb35b06125236bb9"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a98c6106ebbbb2c77cb35b06125236bb9"></a>
<a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper</a>&lt; GRBConstr &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a98c6106ebbbb2c77cb35b06125236bb9">equations_</a></td></tr>
<tr class="memdesc:a98c6106ebbbb2c77cb35b06125236bb9"><td class="mdescLeft">&#160;</td><td class="mdescRight">All equations part of the <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab46930555472c4d857991655324ccb65" title="L1 subproblem model. ">model_</a>. <br/></td></tr>
<tr class="separator:a98c6106ebbbb2c77cb35b06125236bb9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a26dd14ef78bb1a3c7bc9fe722fef0f58"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a26dd14ef78bb1a3c7bc9fe722fef0f58"></a>
<a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper</a>&lt; GRBVar &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a26dd14ef78bb1a3c7bc9fe722fef0f58">variables_</a></td></tr>
<tr class="memdesc:a26dd14ef78bb1a3c7bc9fe722fef0f58"><td class="mdescLeft">&#160;</td><td class="mdescRight">All variables part of the <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab46930555472c4d857991655324ccb65" title="L1 subproblem model. ">model_</a>. <br/></td></tr>
<tr class="separator:a26dd14ef78bb1a3c7bc9fe722fef0f58"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a99b120c226955c114d1185d36b688f90"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a99b120c226955c114d1185d36b688f90"></a>
const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a99b120c226955c114d1185d36b688f90">coupling_equation_name_</a></td></tr>
<tr class="memdesc:a99b120c226955c114d1185d36b688f90"><td class="mdescLeft">&#160;</td><td class="mdescRight">Name of the equation coupling master power suggestion and feasible profile computed in subproblem. <br/></td></tr>
<tr class="separator:a99b120c226955c114d1185d36b688f90"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab21709857572f155cb0a25abbbaa354e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab21709857572f155cb0a25abbbaa354e"></a>
std::vector&lt; int &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab21709857572f155cb0a25abbbaa354e">coupling_equation_</a></td></tr>
<tr class="memdesc:ab21709857572f155cb0a25abbbaa354e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Indices of the equations in <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a98c6106ebbbb2c77cb35b06125236bb9" title="All equations part of the model_. ">equations_</a> that represent the coupling equation (1 entry per timestep). <br/></td></tr>
<tr class="separator:ab21709857572f155cb0a25abbbaa354e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abc8fb896970fdcf7b656bbb29dcff49e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abc8fb896970fdcf7b656bbb29dcff49e"></a>
std::vector&lt; int &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#abc8fb896970fdcf7b656bbb29dcff49e">constraints_</a></td></tr>
<tr class="memdesc:abc8fb896970fdcf7b656bbb29dcff49e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Indices of all entries in <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a98c6106ebbbb2c77cb35b06125236bb9" title="All equations part of the model_. ">equations_</a> that are not a coupling equation. <br/></td></tr>
<tr class="separator:abc8fb896970fdcf7b656bbb29dcff49e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2bc98f8ace120aa946f6fde01ca31a03"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2bc98f8ace120aa946f6fde01ca31a03"></a>
std::vector&lt; int &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a2bc98f8ace120aa946f6fde01ca31a03">model_vars_</a></td></tr>
<tr class="memdesc:a2bc98f8ace120aa946f6fde01ca31a03"><td class="mdescLeft">&#160;</td><td class="mdescRight">Indices of all entries in <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a26dd14ef78bb1a3c7bc9fe722fef0f58" title="All variables part of the model_. ">variables_</a> that are part of the plant model. <br/></td></tr>
<tr class="separator:a2bc98f8ace120aa946f6fde01ca31a03"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae2ec2c96547283c1752defa3e52633bd"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae2ec2c96547283c1752defa3e52633bd"></a>
std::vector&lt; int &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ae2ec2c96547283c1752defa3e52633bd">n_slack_</a></td></tr>
<tr class="memdesc:ae2ec2c96547283c1752defa3e52633bd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Indices of all entries in <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a26dd14ef78bb1a3c7bc9fe722fef0f58" title="All variables part of the model_. ">variables_</a> that are negative slack variables. <br/></td></tr>
<tr class="separator:ae2ec2c96547283c1752defa3e52633bd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6e9d84692dcec80f37e39dc5ca5fcb5b"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a6e9d84692dcec80f37e39dc5ca5fcb5b"></a>
std::vector&lt; int &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a6e9d84692dcec80f37e39dc5ca5fcb5b">p_slack_</a></td></tr>
<tr class="memdesc:a6e9d84692dcec80f37e39dc5ca5fcb5b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Indices of all entries in <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a26dd14ef78bb1a3c7bc9fe722fef0f58" title="All variables part of the model_. ">variables_</a> that are positive slack variables. <br/></td></tr>
<tr class="separator:a6e9d84692dcec80f37e39dc5ca5fcb5b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab3b35f0a6fea154a107e94af1636a656"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab3b35f0a6fea154a107e94af1636a656"></a>
const unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab3b35f0a6fea154a107e94af1636a656">num_timesteps_</a></td></tr>
<tr class="memdesc:ab3b35f0a6fea154a107e94af1636a656"><td class="mdescLeft">&#160;</td><td class="mdescRight">Number of timesteps in the model. <br/></td></tr>
<tr class="separator:ab3b35f0a6fea154a107e94af1636a656"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0ce86dc580bf5272c19c827666e0d8db"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0ce86dc580bf5272c19c827666e0d8db"></a>
std::vector&lt; double &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a0ce86dc580bf5272c19c827666e0d8db">pow_sugg_</a></td></tr>
<tr class="memdesc:a0ce86dc580bf5272c19c827666e0d8db"><td class="mdescLeft">&#160;</td><td class="mdescRight">Power profile suggestion. Unit is multiples of flexible load. <br/></td></tr>
<tr class="separator:a0ce86dc580bf5272c19c827666e0d8db"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a83a18d62c3ee10bbb65ea93797242b29"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a83a18d62c3ee10bbb65ea93797242b29"></a>
const double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a83a18d62c3ee10bbb65ea93797242b29">plant_load_</a></td></tr>
<tr class="memdesc:a83a18d62c3ee10bbb65ea93797242b29"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flexible load of this subproblem in MW. <br/></td></tr>
<tr class="separator:a83a18d62c3ee10bbb65ea93797242b29"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae1a79636eb368c63b73ce3d5e5d7b478"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae1a79636eb368c63b73ce3d5e5d7b478"></a>
const unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ae1a79636eb368c63b73ce3d5e5d7b478">rhs_num_records_</a></td></tr>
<tr class="memdesc:ae1a79636eb368c63b73ce3d5e5d7b478"><td class="mdescLeft">&#160;</td><td class="mdescRight">Number of terms used to compute scalar product on right hand side of a cut. <br/></td></tr>
<tr class="separator:ae1a79636eb368c63b73ce3d5e5d7b478"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Provides an interface for solving L1 subproblems and adding cuts from such problems. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a5f8dfc0bca82b1f5aae9b854f2608578"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">decoop::PlantbusSubproblemL1::PlantbusSubproblemL1 </td>
          <td>(</td>
          <td class="paramtype">const GRBEnv &amp;&#160;</td>
          <td class="paramname"><em>env</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>option_path</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const double&#160;</td>
          <td class="paramname"><em>plant_load</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const unsigned&#160;</td>
          <td class="paramname"><em>num_timesteps</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Constructor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">env</td><td>Reference to the Gurobi environment in which to construct the <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab46930555472c4d857991655324ccb65" title="L1 subproblem model. ">model_</a>. </td></tr>
    <tr><td class="paramname">option_path</td><td>String containing the path to the option file directory. </td></tr>
    <tr><td class="paramname">plant_load</td><td>Flexible load of this subproblem in MW. </td></tr>
    <tr><td class="paramname">num_timesteps</td><td>Number of timesteps in the model. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="ae4531793f2eec41039c4be4905eec28e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double decoop::PlantbusSubproblemL1::ComputeFeasDistance </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Computes distance between suggested power profile and the feasible profile found by the subproblem. Unit is MW. </p>
<dl class="section return"><dt>Returns</dt><dd>Distance to feasible power profile. </dd></dl>

</div>
</div>
<a class="anchor" id="a590527bb3ccf8a97aeb320c1d54b5dd5"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt; double &gt; decoop::PlantbusSubproblemL1::ComputeFeasSol </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Computes the feasible power profile found by the subproblem. Unit is MW. </p>
<dl class="section return"><dt>Returns</dt><dd>Feasible power profile. </dd></dl>

</div>
</div>
<a class="anchor" id="ab15d67a0a1a85ef286644e6a29d0b1cf"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double decoop::PlantbusSubproblemL1::ComputeFeasSol </td>
          <td>(</td>
          <td class="paramtype">const unsigned&#160;</td>
          <td class="paramname"><em>key</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Computes entry of the feasible power profile at given timestep found by the subproblem. Unit is MW. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>Timestep of the feasible power entry. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Feasible power entry at given timestep. </dd></dl>

</div>
</div>
<a class="anchor" id="a2573240404d563487c1f25829b3b4eb9"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double decoop::PlantbusSubproblemL1::GenerateAndVerifyCut </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Computes right hand side of the cut, verifies its correctness and ensures that current power profile suggestion is cut off. </p>
<dl class="section return"><dt>Returns</dt><dd>Right hand side of the cut. </dd></dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname"><a class="el" href="classdecoop_1_1_irrelevant_cut_exception.html" title="Execption class for irrelevant cuts. ">IrrelevantCutException</a></td><td>is thrown if the current power profile suggestion is not cut off. </td></tr>
    <tr><td class="paramname"><a class="el" href="classdecoop_1_1_bad_cut_exception.html" title="Exception class for incorrect cuts. ">BadCutException</a></td><td>is thrown if the correctness check fails. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a2d937ee5b1256ebfff0f5a79f792d98c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double decoop::PlantbusSubproblemL1::get_plant_load </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns flexible load of this subproblem in MW. </p>
<dl class="section return"><dt>Returns</dt><dd>Flexible load of this subproblem. </dd></dl>

</div>
</div>
<a class="anchor" id="a973d94c4cd81963a10dd736488044d16"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt; double &gt; decoop::PlantbusSubproblemL1::get_pow_sugg </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns power profile suggestion. Unit is multiples of flexible load. </p>
<dl class="section return"><dt>Returns</dt><dd>Power profile suggestion. </dd></dl>

</div>
</div>
<a class="anchor" id="a5cb28e40dc33f9a1e84c4ef4def157b3"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double decoop::PlantbusSubproblemL1::get_pow_sugg </td>
          <td>(</td>
          <td class="paramtype">const unsigned&#160;</td>
          <td class="paramname"><em>i</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns entry of the power profile suggestion at a given timestep. Unit is multiples of flexible load. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">i</td><td>Timestep of power suggestion entry. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Power suggestion at given timestep. </dd></dl>

</div>
</div>
<a class="anchor" id="a463a29b7d2cf7b121cb9b5c69992cb98"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double decoop::PlantbusSubproblemL1::GetCurrLhs </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Computes value of the left hand side of the generated cut when current power profile suggestion is inserted. </p>
<dl class="section return"><dt>Returns</dt><dd>Value of left hand side of the cut. </dd></dl>

</div>
</div>
<a class="anchor" id="ac4ddb1eaeeb0a48bcd5a06c36586efe5"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">GRBModel &amp; decoop::PlantbusSubproblemL1::GetModel </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns reference to <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab46930555472c4d857991655324ccb65" title="L1 subproblem model. ">model_</a> object. </p>
<dl class="section return"><dt>Returns</dt><dd>Reference to model. </dd></dl>

</div>
</div>
<a class="anchor" id="ac4b94c28d900106779deb55571355bcc"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int decoop::PlantbusSubproblemL1::GetModelStatus </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns status code of the <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab46930555472c4d857991655324ccb65" title="L1 subproblem model. ">model_</a>. See Gurobi reference manual for meaning of codes. </p>
<dl class="section return"><dt>Returns</dt><dd>Model status code. </dd></dl>

</div>
</div>
<a class="anchor" id="a6e9aa900dfe5f0882030abd72a7a7f7a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double decoop::PlantbusSubproblemL1::GetNewCoeff </td>
          <td>(</td>
          <td class="paramtype">const unsigned&#160;</td>
          <td class="paramname"><em>key</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Computes coefficient of the left hand side of the cut for a given timestep. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>Timestep for which the coefficient is to be calculated. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Coefficient at given timestep. </dd></dl>

</div>
</div>
<a class="anchor" id="a86935d2f7bdf0caf1f0d1b9ee6ccb7df"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt; double &gt; decoop::PlantbusSubproblemL1::GetNewCoeffs </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Computes all coefficients of the left hand side of the cut. </p>
<dl class="section return"><dt>Returns</dt><dd>Vector holding all coefficients. </dd></dl>

</div>
</div>
<a class="anchor" id="a91ffead887f3d8961ca6d787b93168d9"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double decoop::PlantbusSubproblemL1::GetNewRhs </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Computes right hand side of the cut generated from current power profile suggestion. </p>
<dl class="section return"><dt>Returns</dt><dd>Right hand side of the cut.</dd></dl>
<p>Implementation currently does not check the model status here, so calling this without ensuring the model has been solved may result in an exception thrown by Gurobi. </p>

</div>
</div>
<a class="anchor" id="a338929b552e8af9a7612f3bb4ae12a32"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt; double &gt; decoop::PlantbusSubproblemL1::GetNSlackValues </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns values of negative slack variables. </p>
<dl class="section return"><dt>Returns</dt><dd>Vector containing values of negative slack variables. </dd></dl>

</div>
</div>
<a class="anchor" id="ab8a27c2b34a6bef9695e76b42c6a62f3"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt; double &gt; decoop::PlantbusSubproblemL1::GetPSlackValues </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns values of positive slack variables. </p>
<dl class="section return"><dt>Returns</dt><dd>Vector containing values of positive slack variables. </dd></dl>

</div>
</div>
<a class="anchor" id="a148da0d8b1e81458343ad5e95b38ecec"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double decoop::PlantbusSubproblemL1::GetSubproblemObjective </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns objective value of the <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab46930555472c4d857991655324ccb65" title="L1 subproblem model. ">model_</a>. </p>
<p>The objective value sums up the slacks that are required to find the minimum feasible modification of the suggested power profile. Unit is multiples of flexible load. </p>
<dl class="section return"><dt>Returns</dt><dd>Objective value. </dd></dl>

</div>
</div>
<a class="anchor" id="ab119d790de2b3b817927acfa1d2e314e"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long decoop::PlantbusSubproblemL1::InitObject </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Fills <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ab21709857572f155cb0a25abbbaa354e" title="Indices of the equations in equations_ that represent the coupling equation (1 entry per timestep)...">coupling_equation_</a>, <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#abc8fb896970fdcf7b656bbb29dcff49e" title="Indices of all entries in equations_ that are not a coupling equation. ">constraints_</a>, <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a2bc98f8ace120aa946f6fde01ca31a03" title="Indices of all entries in variables_ that are part of the plant model. ">model_vars_</a>, <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#ae2ec2c96547283c1752defa3e52633bd" title="Indices of all entries in variables_ that are negative slack variables. ">n_slack_</a> and <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a6e9d84692dcec80f37e39dc5ca5fcb5b" title="Indices of all entries in variables_ that are positive slack variables. ">p_slack_</a>. </p>
<dl class="section return"><dt>Returns</dt><dd>Sum of sizes of <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#abc8fb896970fdcf7b656bbb29dcff49e" title="Indices of all entries in equations_ that are not a coupling equation. ">constraints_</a> and <a class="el" href="classdecoop_1_1_plantbus_subproblem_l1.html#a2bc98f8ace120aa946f6fde01ca31a03" title="Indices of all entries in variables_ that are part of the plant model. ">model_vars_</a>. </dd></dl>

</div>
</div>
<a class="anchor" id="aad54229e7d85a7a6cb8cf2eeb56a169a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void decoop::PlantbusSubproblemL1::set_pow_sugg </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; double &gt; &amp;&#160;</td>
          <td class="paramname"><em>in</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sets power profile suggestion. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">in</td><td>Reference to vector containing the new power profile suggestion. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a4c1012cde8398a015a1527af62a8c6b6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void decoop::PlantbusSubproblemL1::set_pow_sugg </td>
          <td>(</td>
          <td class="paramtype">const unsigned&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const double&#160;</td>
          <td class="paramname"><em>val</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sets power suggestion at single timestep. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>Timestep to set power suggestion at. </td></tr>
    <tr><td class="paramname">val</td><td>Power suggestion. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>inc/<a class="el" href="coop_benders_subproblem_l1_8hpp_source.html">coopBendersSubproblemL1.hpp</a></li>
<li>src/coopBendersSubproblemL1.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.5
</small></address>
</body>
</html>
